plugin simpleMeshMod Vu_Parse_Quads
	name:"Vu_Parse_Quads"
	classID:#(0x3D3BEC97, 0xD238D3)
	category:"Max Creation Graph"
(
	local pluginDefinitionFile -- the plugin definition file
	local pluginInstance -- the plugin instance created from the plugin definition
	local _meshWrapper -- the dotnet wrapper around the stack mesh pointer
	local argsType = dotNetClass "System.Object[]" -- used when creating args array
	local dotnet_ValueToDotNetObject = dotnet.ValueToDotNetObject
	local tmHandler

	-- function wrappers
	local _meshWrapper_SetValue
	local pluginInstance_UpdateMesh

	-- value wrapper local and function wrapper declarations
	local PickUnwrapperWrapper, PickUnwrapperWrapper_SetValue
	local meshWrapper, meshWrapper_SetValue
	local Pick_CloneWrapper, Pick_CloneWrapper_SetValue


	parameters main rollout:params
	(
		Show_Emitter ui:Show_Emitter default:True type:#boolean animatable:true
		Populate_Clone ui:Populate_Clone default:False type:#boolean animatable:true
		UseUnwrap ui:UseUnwrap default:False type:#boolean animatable:true
		PickUnwrapper ui:PickUnwrapper type:#node useNodeOsValidity:true useNodeTmValidity:true
		Reverse ui:Reverse default:False type:#boolean animatable:true
		Grow ui:Grow default:True type:#boolean animatable:true
		OffsetFirstTri ui:OffsetFirstTri default:False type:#boolean animatable:true
		Face_ ui:Face_ default:0 type:#integer animatable:true
		Pick_Clone ui:Pick_Clone type:#node useNodeOsValidity:true useNodeTmValidity:true
		Up_Axis ui:Up_Axis default:0 type:#integer animatable:true
		_dummy type:#boolean -- this exists to enable easy invalidation of the object        
		pluginGraph type:#filename assettype:#MaxCreationGraph readOnly:true enumAsAsset:true 
        pluginGraphDependencies type:#filenametab assettype:#MaxCreationGraph readOnly:true enumAsAsset:true tabSize:0 tabSizeVariable:true
    ) 

rollout params "Parameters"
	(
		checkbox Grow "Grow" checked:Grow.state
		spinner Face_ "Face:" range:[0, 9999999, 0] type:#integer
		checkbox OffsetFirstTri "OffsetFirstTri" checked:OffsetFirstTri.state
		checkbox Reverse "Reverse" checked:Reverse.state

	group "Experimental Clone Quad!!!"
	(
		label lab11 "(Reverse Clone mode" align:#left
		label lab12 "not working properly)" align:#left
		pickbutton Pick_Clone "Pick Clone" autodisplay:true type:#node
		slider Up_Axis "Up Axis" range:[0, 2, 0] type:#integer
		label lab13 "X                  Y                 Z" align:#left
		checkbox Populate_Clone "Populate Clone" checked:Populate_Clone.state
		checkbox Show_Emitter "Show Emitter" checked:Show_Emitter.state

	)
	group "Experimental !!!"
	(
		label lab21 "Use a plane as  Unwrapper" align:#left
		label lab22 "then tweak the res and" align:#left
		label lab23 "dimensions of Unwrapper." align:#left
		label lab24 "Then add Unwrap UVW mod" align:#left
		label lab25 "to see results..." align:#left
		checkbox UseUnwrap "Use Unwrapper" checked:False
		pickbutton PickUnwrapper "PickUnwrapper" autodisplay:true type:#node
	)
	)

rollout inforoll "About"
	(
		Group "Vu ParseQuads Info"
		(
			label lab91 "Author: Vu Nguyen" align:#left
			label lab92 "(c) Vu Nguyen 2015" align:#left
			label lab94 "Version: 2.02.00" align:#left
			label lab95 "Email: vusta@hotmail.com" align:#left
		)

	)

	fn initialize = 
	(
		pluginDefinitionFile = @"C:/Users/Honey/Autodesk/3ds Max 2016/Max Creation Graph/Tools/Vu_Parse_Quads.maxtool"
		local c = dotNetClass "Viper3dsMaxBridge.ModifierPluginInstance"
		local cid = this.classId
		local refMakerWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.ReferenceMaker"
		refMakerWrapper = refMakerWrapperClass._CreateWrapper this
		pluginInstance = c.CreateInstance cid[1] cid[2] pluginDefinitionFile refMakerWrapper
		pluginInstance_UpdateMesh = pluginInstance.UpdateMesh
		local meshWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.Mesh"
		_meshWrapper = meshWrapperClass._CreateWrapper undefined
		_meshWrapper_SetValue = _meshWrapper._SetValue
		pluginGraph = pluginDefinitionFile
		pluginGraphDependencies = #(@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DivideByTwo.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Lesser.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MultiplyByTwo.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\PlusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MinusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array2.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SkipOne.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\ChooseAxis.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array3.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\VuQuadNormal.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SelectByIndex.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\AverageVector.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Sum.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\RotationBetweenUnitVectors.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RotateMesh.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DeformMeshPoints.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Origin.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\VuQuadMidpoint.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\TransformMesh.maxcompound")

		-- value wrapper local initializations
		local PickUnwrapperWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.INode"
		PickUnwrapperWrapper = PickUnwrapperWrapperClass._CreateWrapper (undefined)
		PickUnwrapperWrapper_SetValue = PickUnwrapperWrapper._SetValue
		local meshWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Mesh"
		meshWrapper = meshWrapperClass._CreateWrapper (undefined)
		meshWrapper_SetValue = meshWrapper._SetValue
		local Pick_CloneWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.INode"
		Pick_CloneWrapper = Pick_CloneWrapperClass._CreateWrapper (undefined)
		Pick_CloneWrapper_SetValue = Pick_CloneWrapper._SetValue

	)

	fn updateMesh = 
	(

		if (pluginInstance == undefined) then ( return undefined )
		local args = dotnet_ValueToDotNetObject #(Show_Emitter, Populate_Clone, UseUnwrap, PickUnwrapperWrapper, Reverse, Grow, meshWrapper, OffsetFirstTri, Face_, Pick_CloneWrapper, Up_Axis) argsType
		pluginInstance_UpdateMesh (currentTime as integer) _meshWrapper args
	)
	
	on modifyMesh do
	(
		try 
		(
			_meshWrapper_SetValue mesh
			PickUnwrapperWrapper_SetValue PickUnwrapper
			Pick_CloneWrapper_SetValue Pick_Clone
			meshWrapper_SetValue mesh

			updateMesh()
			_meshWrapper_SetValue undefined

		)
		catch()
		ok
	)

	on create do 
	(
		initialize()
	)

	on clone fromObj do 
	(
		initialize()
	)

	on load do 
	(
		initialize()
	)

	on update do 
	(
		initialize()
	)
)
